Index: /trunk/source/Lib/TLibCommon/TComWedgelet.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComWedgelet.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComWedgelet.h	(revision 1413)
@@ -43,5 +43,5 @@
 #include <vector>
 
-#if NH_3D_DMM
+#if NH_3D
 #define DMM_OFFSET     (NUM_INTRA_MODE+1) // offset for DMM and RBC mode numbers
 #define DMM_MIN_SIZE                   4  // min. block size for DMM and RBC modes
@@ -182,5 +182,5 @@
 // type definition wedgelet node list
 typedef std::vector<TComWedgeNode> WedgeNodeList;
-#endif //NH_3D_DMM
+#endif //NH_3D
 
 #endif // __TCOMWEDGELET__
Index: /trunk/source/Lib/TLibCommon/TComWeightPrediction.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComWeightPrediction.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComWeightPrediction.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComWeightPrediction.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComWeightPrediction.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComWeightPrediction.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComYuv.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComYuv.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComYuv.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -491,5 +491,5 @@
 #endif
 
-#if NH_3D_ARP
+#if NH_3D
 Void TComYuv::addARP( TComYuv* pcYuvSrc0, TComYuv* pcYuvSrc1, UInt uiAbsPartIdx, UInt uiWidth, UInt uiHeight, Bool bClip, const BitDepths &clipBitDepths )
 {
Index: /trunk/source/Lib/TLibCommon/TComYuv.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComYuv.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComYuv.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -208,5 +208,4 @@
 #endif
 #if NH_3D
-#if NH_3D_ARP
   Void         addARP                     ( TComYuv* pcYuvSrc0, TComYuv* pcYuvSrc1, UInt uiAbsPartIdx, UInt uiWidth , UInt uiHeight , Bool bClip, const BitDepths &clipBitDepths );
   Void         addARPLuma                 ( TComYuv* pcYuvSrc0, TComYuv* pcYuvSrc1, UInt uiAbsPartIdx, UInt uiWidth , UInt uiHeight , Bool bClip, const BitDepths &clipBitDepths );
@@ -221,5 +220,4 @@
   Void         xxMultiplyLine             ( Pel * pSrcDst , UInt uiWidth , UChar dW );
 #endif
-#endif
 
 };// END CLASS DEFINITION TComYuv
Index: /trunk/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TypeDef.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TypeDef.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -40,4 +40,6 @@
 #endif
 #include <vector>
+#include <utility>
+
 //! \ingroup TLibCommon
 //! \{
@@ -60,22 +62,16 @@
 #define NH_MV          ( HEVC_EXT != 0)
 #define NH_3D          ( HEVC_EXT == 2)
+
+#define NH_MV_ALLOW_NON_CONFORMING                0   // Allow non-conforming representations formats
 /////////////////////////////////////////////////////////////////////////////////////////
 ///////////////////////////////////   FIXES AND INTEGRATIONS     ////////////////////////
 /////////////////////////////////////////////////////////////////////////////////////////
 #if NH_MV
-// Recent bug fixes
-#define RM_INIT_FIX                      1
-#define RM_FIX_SETUP                     1
-#define NH_MV_FIX_VERT_MV_REST                         1
-
-#define NH_3D_FIX_INTRA_SDC_VSO_OFF              1
-#define NH_3D_FIX_TICKET_114                     1  //Mismatch between text and software on DPB size syntax
-#define NH_3D_FIX_LEAK                           1
-// Things that needs to be fixed also in the Specification ...
+// Things that needs to be fixed also in the Specification ... CHECK if this has been done
 #define NH_MV_FIX_NO_REF_PICS_CHECK               1 // !!SPEC!!
 #define NH_MV_FIX_INIT_NUM_ACTIVE_REF_LAYER_PICS  1 // Derivation of NumActiveRefLayerPIcs. !!SPEC!!
 #define NH_MV_FIX_NUM_POC_TOTAL_CUR               1 // Derivation of NumPocTotalCur for IDR pictures. !!SPEC!!
 // To be done 
-#define NH_MV_HLS_PTL_LIMITS                       0
+#define NH_MV_HLS_PTL_LIMITS                      0
 #define NH_MV_SEI_TBD                             0
 #endif
@@ -83,15 +79,31 @@
 ///////////////////////////////////   MAJOR DEFINES   ///////////////////////////////////
 /////////////////////////////////////////////////////////////////////////////////////////
+
+
 #if NH_MV
 #define NH_MV_ENC_DEC_TRAC                 1  //< CU/PU level tracking
 #if NH_3D
-#define NH_3D_INTEGER_MV_DEPTH            1
-#define NH_3D_ENC_DEPTH                   1   // Encoder optimizations for depth, incl.
+#define NH_3D_VSO                          1  // VSO, View synthesis optimization, includes:
+// HHI_VSO
+// HHI_VSO_LS_TABLE_M23714 enable table base Lagrange multiplier optimization
+// SAIT_VSO_EST_A0033, JCT3V-A0033 modification 3
+// LGE_WVSO_A0119
+// SCU_HS_VSD_BUGFIX_IMPROV_G0163
+
+#define NH_3D_FAST_TEXTURE_ENCODING        1   // Fast merge mode decision and early CU determination for texture component of dependent view, JCT3V-E0173
+
+/////////////////////////////////////////////////////////////////////////////////////////
+///////////////////////////////////   REMOVED DEFINES   /////////////////////////////////
+/////////////////////////////////////////////////////////////////////////////////////////
+
+//#define NH_3D_INTEGER_MV_DEPTH            1
+
+//#define NH_3D_ENC_DEPTH                   1   // Encoder optimizations for depth, incl.
                                               // HHI_DEPTH_INTRA_SEARCH_RAU_C0160
                                               // LG_ZEROINTRADEPTHRESI_A0087
                                               // HHI_DMM4_ENC_I0066
                                               // H_3D_FAST_DEPTH_INTRA
-#define NH_3D_FAST_TEXTURE_ENCODING       1   // Fast merge mode decision and early CU determination for texture component of dependent view, JCT3V-E0173
-#define NH_3D_ARP                         1  // Advanced residual prediction (ARP), JCT3V-D0177
+
+//#define NH_3D_ARP                         1  // Advanced residual prediction (ARP), JCT3V-D0177
                                              // QC_MTK_INTERVIEW_ARP_F0123_F0108 JCT3V-F0123; JCT3V-F0108
                                              // SHARP_ARP_REF_CHECK_F0105        ARP reference picture selection and DPB check
@@ -105,15 +117,9 @@
                                              // SEC_ARP_VIEW_REF_CHECK_J0037    Signaling iv_res_pred_weight_idx when the current slice has both view and temporal reference picture(s), JCT3V-J0037 item1
                                              // SEC_ARP_REM_ENC_RESTRICT_K0035    Removal of encoder restriction of ARP, JCT3V-K0035
-#define NH_3D_QTL                          1
-#define NH_3D_QTLPC                        1   // OL_QTLIMIT_PREDCODING_B0068 //JCT3V-B0068
+//#define NH_3D_QTL                          1
+//#define NH_3D_QTLPC                        1   // OL_QTLIMIT_PREDCODING_B0068 //JCT3V-B0068
                                               // HHI_QTLPC_RAU_OFF_C0160 JCT3V-C0160 change 2: quadtree limitation and predictive coding switched off in random access units
                                               // MTK_TEX_DEP_PAR_G0055 Texture-partition-dependent depth partition. JCT3V-G0055
-#define NH_3D_VSO                          1   // VSO, View synthesis optimization, includes:
-                                              // HHI_VSO
-                                              // HHI_VSO_LS_TABLE_M23714 enable table base Lagrange multiplier optimization
-                                              // SAIT_VSO_EST_A0033, JCT3V-A0033 modification 3
-                                              // LGE_WVSO_A0119
-                                              // SCU_HS_VSD_BUGFIX_IMPROV_G0163
-#define NH_3D_NBDV                         1   // Neighboring block disparity derivation
+//#define NH_3D_NBDV                         1   // Neighboring block disparity derivation
                                               // QC_JCT3V-A0097
                                               // LGE_DVMCP_A0126
@@ -131,5 +137,5 @@
                                               // MTK_TEXTURE_MRGCAND_BUGFIX_E0182  Bug fix for TEXTURE MERGING CANDIDATE     , JCT3V-E0182
                                               // LGE_SIMP_DISP_AVAIL_J0041    // Use 2 status for disparity availability - DISP_AVAILABLE and DISP_NONE
-#define NH_3D_IC                          1   // Illumination Compensation, JCT3V-B0045, JCT3V-C0046, JCT3V-D0060
+//#define NH_3D_IC                          1   // Illumination Compensation, JCT3V-B0045, JCT3V-C0046, JCT3V-D0060
                                               // Unifying rounding offset, for IC part, JCT3V-D0135
                                               // Full Pel Interpolation for Depth, HHI_FULL_PEL_DEPTH_MAP_MV_ACC
@@ -144,6 +150,6 @@
                                               // SEC_IC_NEIGHBOR_CLIP_I0080    // Clipping of neighboring sample position, JCT3V-I0080
                                               // LGE_CHROMA_IC_J0050_J0034
-#if NH_3D_NBDV
-#define NH_3D_NBDV_REF                     1   // Depth oriented neighboring block disparity derivation
+//#if NH_3D_NBDV
+//#define NH_3D_NBDV_REF                     1   // Depth oriented neighboring block disparity derivation
                                               // MTK_D0156
                                               // MERL_D0166: Reference view selection in NBDV & Bi-VSP
@@ -152,6 +158,6 @@
                                               // NTT_DoNBDV_VECTOR_CLIP_E0141 disparity vector clipping in DoNBDV, JCT3V-E0141 and JCT3V-E0209
                                               // SEC_VER_DONBDV_H0103          Vertical DV Restriction for DoNBDV
-#endif
-#define NH_3D_VSP                          1   // View synthesis prediction
+//#endif
+//#define NH_3D_VSP                          1   // View synthesis prediction
                                               // MERL_C0152: Basic VSP
                                               // MERL_D0166: Reference view selection in NBDV & Bi-VSP
@@ -171,6 +177,6 @@
                                               // MTK_MRG_LIST_SIZE_CLEANUP_J0059   1   // Include VSP for deriving merge candidate list size, JCT3V-J0059
                                               // SEC_A1_BASED_VSP_J0039            1   // Removal of redundant VSP in Merge list
-#define NH_3D_MLC                          1
-#define NH_3D_IV_MERGE                     1  // Inter-view motion merge candidate
+//#define NH_3D_MLC                          1
+//#define NH_3D_IV_MERGE                     1  // Inter-view motion merge candidate
                                               // HHI_INTER_VIEW_MOTION_PRED
                                               // SAIT_IMPROV_MOTION_PRED_M24829, improved inter-view motion vector prediction
@@ -193,11 +199,11 @@
                                               // SEC_SIMP_SHIFTED_DV_I0086     Simplification of Shifted DV candidate, JCT3V-I0086
                                               // SEC_SHIFTED_IVMC_POS_K0036    Position Derivation for Shifted-IVMC, JCT3V-K0036
-#define NH_3D_TEXT_MERGE                  1
+//#define NH_3D_TEXT_MERGE                  1
                                               // TEXTURE MERGING CANDIDATE     , JCT3V-C0137
                                               // EC_MPI_ENABLING_MERGE_F0150, MPI flag in VPS and enabling in Merge mode
-#define NH_3D_TMVP                        1   // QC_TMVP_C0047
+//#define NH_3D_TMVP                        1   // QC_TMVP_C0047
                                               // Sony_M23639
                                               // H_3D_TMVP_SCALING_FIX_K0053       1   // QC/CY for K0053
-#define NH_3D_DMM                         1   // Depth modeling modes
+//#define NH_3D_DMM                         1   // Depth modeling modes
                                               // HHI_DMM_PRED_TEX
                                               // HHI_DMM_WEDGE_INTRA
@@ -223,5 +229,5 @@
                                               // MTK_DMM_SIM_J0035
                                               // SHARP_DMM_CLEAN_K0042             1   // Generate DMM pattern with rotation
-#define NH_3D_DLT                         1   // Depth Lookup Table
+//#define NH_3D_DLT                         1   // Depth Lookup Table
                                               // HHI_DELTADC_DLT_D0035
                                               // LGE_PRED_RES_CODING_DLT_DOMAIN_F0159 JCT3V-F0159
@@ -231,6 +237,6 @@
                                               // RWTH_DLT_CLIP_I0057
                                               // SHARP_DLT_SIMP_J0029 DLT(DepthValue2Idx[]) table derivation cleanup
-#define NH_3D_SDC_INTRA                   1   // Segment-wise DC Coding method for INTRA
-#define NH_3D_SDC_INTER                   1   // Segment-wise DC Coding method for INTER
+//#define NH_3D_SDC_INTRA                   1   // Segment-wise DC Coding method for INTRA
+//#define NH_3D_SDC_INTER                   1   // Segment-wise DC Coding method for INTER
                                               // RWTH_SDC_DLT_B0036
                                               // INTEL_SDC64_D0193
@@ -252,10 +258,10 @@
                                               // LGE_INTER_SDC_E0156 Enable inter SDC for depth coding
                                               // SEC_INTER_SDC_G0101 Improved inter SDC with multiple DC candidates
-#define NH_3D_SPIVMP                       1   // H_3D_SPIVMP JCT3V-F0110: Sub-PU level inter-view motion prediction
+//#define NH_3D_SPIVMP                       1   // H_3D_SPIVMP JCT3V-F0110: Sub-PU level inter-view motion prediction
                                               // SEC_SPIVMP_MCP_SIZE_G0077, Apply SPIVMP only to 2Nx2N partition, JCT3V-G0077
                                               // QC_SPIVMP_MPI_G0119 Sub-PU level MPI merge candidate
                                               // Simplification on Sub-PU level temporal interview motion prediction
                                               // MPI_SUBPU_DEFAULT_MV_H0077_H0099_H0111_H0133
-#define NH_3D_DBBP                         1   // DBBP: Depth-based Block Partitioning and Merging
+//#define NH_3D_DBBP                         1   // DBBP: Depth-based Block Partitioning and Merging
                                               // MTK_DBBP_AMP_REM_H0072
                                               // RWTH_DBBP_NO_SPU_H0057
@@ -270,7 +276,6 @@
                                               // RWTH_DBBP_NO_SATD_K0028
                                               // HS_DBBP_CLEAN_K0048
-#define NH_3D_DIS                         1   // Depth intra skip
+//#define NH_3D_DIS                         1   // Depth intra skip
                                               // SEC_DEPTH_INTRA_SKIP_MODE_K0033  Depth intra skip mode
-#define H_3D_FCO                          0   // Flexible coding order for 3D
 // OTHERS
                                               // MTK_SONY_PROGRESSIVE_MV_COMPRESSION_E0170 // Progressive MV Compression, JCT3V-E0170
@@ -315,21 +320,21 @@
 #endif
 ////   ****** NEIGHBOURING BLOCK-BASED DISPARITY VECTOR  *********
-#if NH_3D_NBDV
+#if NH_3D
 #define DVFROM_LEFT                       0
 #define DVFROM_ABOVE                      1
 #define IDV_CANDS                         2
-#endif
+
 /////////////////////////////////////////////////////////////////////////////////////
 /// GT: Move values which are not flags to CommonDef.h and convert to static int !!
 ///////////////////////////////////////////////////////////////////////////////////
 ///// ***** ILLUMATION COMPENSATION *********
-#if NH_3D_IC
+
 #define IC_REG_COST_SHIFT                 7
 #define IC_CONST_SHIFT                    5
 #define IC_SHIFT_DIFF                     12
 #define IC_LOW_LATENCY_ENCODING_THRESHOLD 0.1 // Threshold for low-latency IC encoding in JCT3V-H0086
-#endif
+
 ///// ***** DEPTH BASED BLOCK PARTITIONING *********
-#if NH_3D_DBBP
+
 #define DBBP_INVALID_SHORT                (-4)
 #endif
@@ -358,12 +363,6 @@
 #endif
 
-#if NH_MV
-#if ENC_DEC_TRACE
-#define GT_DEBUG   1
-#else
-#define GT_DEBUG   0
-#endif
-#endif
 #define DEC_NUH_TRACE                                     0 ///< When trace enabled, enable tracing of NAL unit headers at the decoder (currently not possible at the encoder)
+
 #define PRINT_RPS_INFO                                    0 ///< Enable/disable the printing of bits used to send the RPS.
 // ====================================================================================================================
@@ -371,13 +370,28 @@
 // ====================================================================================================================
 #define DECODER_CHECK_SUBSTREAM_AND_SLICE_TRAILING_BYTES  1 ///< TODO: integrate this macro into a broader conformance checking system.
-#define T0196_SELECTIVE_RDOQ                              1 ///< selective RDOQ
-#define U0040_MODIFIED_WEIGHTEDPREDICTION_WITH_BIPRED_AND_CLIPPING 1
-#define U0033_ALTERNATIVE_TRANSFER_CHARACTERISTICS_SEI    1 ///< Alternative transfer characteristics SEI message (JCTVC-U0033, with syntax naming from V1005)
-#define W0062_RECALCULATE_QP_TO_ALIGN_WITH_LAMBDA         0 ///< This recalculates QP to align with the derived lambda (same relation as for all intra coding is used). Currently disabled by default.
-#define OPTIONAL_RESET_SAO_ENCODING_AFTER_IRAP            1 ///< Adds command line option to reset SAO parameters after each IRAP.
-
+#define X0038_LAMBDA_FROM_QP_CAPABILITY                   ( HEVC_EXT == 0 ) ///< This approach derives lambda from QP+QPoffset+QPoffset2. QPoffset2 is derived from QP+QPoffset using a linear model that is clipped between 0 and 3.
+                                                            // To use this capability enable config parameter LambdaFromQpEnable
+                                                            // GT: This is currently disabled for MV-HEVC and 3D-HEVC. Enabling requires modifications of the cfg-files
+#define JCTVC_Y0038_PARAMS                                1
+
+#define JVET_E0059_FLOATING_POINT_QP_FIX                  1 ///< Replace floating point QP with a source-file frame number.
+#define JVET_G0101_QP_SWITCHING                           1 ///< After switching POC, increase base QP instead of frame level QP.
+
+#define JVET_F0064_MSSSIM                                 1 ///< Calculate MS-SSIM scores
+
+#ifndef EXTENSION_360_VIDEO
+#define EXTENSION_360_VIDEO                               0   ///< extension for 360/spherical video coding support; this macro should be controlled by makefile, as it would be used to control whether the library is built and linked
+#endif
+
+#define MCTS_ENC_CHECK                                    1  ///< Temporal MCTS encoder constraint and decoder checks. Also requires SEITMCTSTileConstraint to be enabled to enforce constraint
 // ====================================================================================================================
 // Tool Switches
 // ====================================================================================================================
+
+// Please also refer to "TDecConformance.h" for DECODER_PARTIAL_CONFORMANCE_CHECK
+
+#define REDUCED_ENCODER_MEMORY                            0 ///< When 1, the encoder will allocate TComPic memory when required and release it when no longer required.
+// GT: To be aligned
+
 #define ADAPTIVE_QP_SELECTION                             1 ///< G382: Adaptive reconstruction levels, non-normative part for adaptive QP selection
 #define AMP_ENC_SPEEDUP                                   1 ///< encoder only speed-up by AMP mode skipping
@@ -399,10 +413,12 @@
 #define RExt__HIGH_BIT_DEPTH_SUPPORT                                           0 ///< 0 (default) use data type definitions for 8-10 bit video, 1 = use larger data types to allow for up to 16-bit video (originally developed as part of N0188)
 #endif
-#define U0132_TARGET_BITS_SATURATION                      1 ///< Rate control with target bits saturation method
-#ifdef  U0132_TARGET_BITS_SATURATION
-#define V0078_ADAPTIVE_LOWER_BOUND                        1 ///< Target bits saturation with adaptive lower bound
-#endif
-#define W0038_DB_OPT                                      1 ///< adaptive DB parameter selection, LoopFilterOffsetInPPS and LoopFilterDisable are set to 0 and DeblockingFilterMetric=2;
-#define W0038_CQP_ADJ                                     1 ///< chroma QP adjustment based on TL, CQPTLAdjustEnabled is set to 1;
+
+#if defined __SSE2__ || defined __AVX2__ || defined __AVX__ || defined _M_AMD64 || defined _M_X64
+#define VECTOR_CODING__INTERPOLATION_FILTER               1 ///< enable vector coding for the interpolation filter. 1 (default if SSE possible) disable SSE vector coding. Should not affect RD costs/decisions. Code back-ported from JEM2.0.
+#define VECTOR_CODING__DISTORTION_CALCULATIONS            1 ///< enable vector coding for distortion calculations   1 (default if SSE possible) disable SSE vector coding. Should not affect RD costs/decisions. Code back-ported from JEM2.0.
+#else
+#define VECTOR_CODING__INTERPOLATION_FILTER               0 ///< enable vector coding for the interpolation filter. 0 (default if SSE not possible) disable SSE vector coding. Should not affect RD costs/decisions. Code back-ported from JEM2.0.
+#define VECTOR_CODING__DISTORTION_CALCULATIONS            0 ///< enable vector coding for distortion calculations   0 (default if SSE not possible) disable SSE vector coding. Should not affect RD costs/decisions. Code back-ported from JEM2.0.
+#endif
 
 // ====================================================================================================================
@@ -706,5 +722,5 @@
   MD_ABOVE_LEFT         ///< MVP of above left block
 };
-#if NH_3D_MLC
+#if NH_3D
 enum DefaultMergCandOrder
 {
@@ -858,6 +874,8 @@
 #if NH_MV
     ,MULTIVIEWMAIN = 6,
-#if NH_3D
     MAIN3D = 8,
+#if NH_MV_ALLOW_NON_CONFORMING
+    MULTIVIEWMAIN_NONCONFORMING = 29,
+    MAIN3D_NONCONFORMING= 31,
 #endif
 #endif
@@ -870,4 +888,5 @@
     MAIN = 0,
     HIGH = 1,
+    NUMBER_OF_TIERS = 2
   };
   enum Name
@@ -998,4 +1017,13 @@
   NAL_UNIT_INVALID,
 };
+
+enum LumaLevelToDQPMode
+{
+  LUMALVL_TO_DQP_DISABLED   = 0,
+  LUMALVL_TO_DQP_AVG_METHOD = 1, // use average of CTU to determine luma level
+  LUMALVL_TO_DQP_MAX_METHOD = 2,  // use maximum value of CTU to determine luma level
+  LUMALVL_TO_DQP_NUM_MODES  = 3
+};
+
 #if NH_MV
 /// scalability types
@@ -1159,4 +1187,23 @@
   UShort    whitePoint[2];
 };
+
+struct LumaLevelToDeltaQPMapping
+{
+  LumaLevelToDQPMode                 mode;             ///< use deltaQP determined by block luma level
+  Double                             maxMethodWeight;  ///< weight of max luma value when mode = 2
+  std::vector< std::pair<Int, Int> > mapping;          ///< first=luma level, second=delta QP.
+  Bool isEnabled() const { return mode!=LUMALVL_TO_DQP_DISABLED; }
+};
+
+struct WCGChromaQPControl
+{
+  Bool isEnabled() const { return enabled; }
+  Bool   enabled;         ///< Enabled flag (0:default)
+  Double chromaCbQpScale; ///< Chroma Cb QP Scale (1.0:default)
+  Double chromaCrQpScale; ///< Chroma Cr QP Scale (1.0:default)
+  Double chromaQpScale;   ///< Chroma QP Scale (0.0:default)
+  Double chromaQpOffset;  ///< Chroma QP Offset (0.0:default)
+};
+
 //! \}
 #endif
Index: /trunk/source/Lib/TLibDecoder/AnnexBread.cpp
===================================================================
--- /trunk/source/Lib/TLibDecoder/AnnexBread.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibDecoder/AnnexBread.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibDecoder/AnnexBread.h
===================================================================
--- /trunk/source/Lib/TLibDecoder/AnnexBread.h	(revision 1412)
+++ /trunk/source/Lib/TLibDecoder/AnnexBread.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibDecoder/NALread.cpp
===================================================================
--- /trunk/source/Lib/TLibDecoder/NALread.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibDecoder/NALread.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibDecoder/NALread.h
===================================================================
--- /trunk/source/Lib/TLibDecoder/NALread.h	(revision 1412)
+++ /trunk/source/Lib/TLibDecoder/NALread.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
